Loading...
Searching...
No Matches
fastjet::PseudoJetStructureBase Class Reference
Access to extra information

Contains any information related to the clustering that should be directly accessible to PseudoJet. More...

`#include <fastjet/PseudoJetStructureBase.hh>`

Inheritance diagram for fastjet::PseudoJetStructureBase:
[legend]

## Public Member Functions

| PseudoJetStructureBase ()
| default ctor
virtual | ~PseudoJetStructureBase ()
| default (virtual) dtor
virtual std::string | description () const
| description
Direct access to the associated ClusterSequence object.
Get access to the associated ClusterSequence (if any)
virtual bool | has_associated_cluster_sequence () const
| returns true if there is an associated ClusterSequence
virtual const ClusterSequence * | associated_cluster_sequence () const
| get a (const) pointer to the parent ClusterSequence (NULL if inexistent)
virtual bool | has_valid_cluster_sequence () const
| returns true if this PseudoJet has an associated and still valid ClusterSequence.
virtual const ClusterSequence * | validated_cs () const
| if the jet has a valid associated cluster sequence then return a pointer to it; otherwise throw an error
virtual const ClusterSequenceAreaBase * | validated_csab () const
| if the jet has valid area information then return a pointer to the associated ClusterSequenceAreaBase object; otherwise throw an error
Methods for access to information about jet structure
These allow access to jet constituents, and other jet subtructure information. They only work if the jet is associated with a ClusterSequence.
virtual bool | has_partner (const PseudoJet &reference, PseudoJet &partner) const
| check if it has been recombined with another PseudoJet in which case, return its partner through the argument.
virtual bool | has_child (const PseudoJet &reference, PseudoJet &child) const
| check if it has been recombined with another PseudoJet in which case, return its child through the argument.
virtual bool | has_parents (const PseudoJet &reference, PseudoJet &parent1, PseudoJet &parent2) const
| check if it is the product of a recombination, in which case return the 2 parents through the 'parent1' and 'parent2' arguments.
virtual bool | object_in_jet (const PseudoJet &reference, const PseudoJet &jet) const
| check if the reference PseudoJet is contained the second one passed as argument.
virtual bool | has_constituents () const
| return true if the structure supports constituents.
virtual std::vector< PseudoJet > | constituents (const PseudoJet &reference) const
| retrieve the constituents.
virtual bool | has_exclusive_subjets () const
| return true if the structure supports exclusive_subjets.
virtual std::vector< PseudoJet > | exclusive_subjets (const PseudoJet &reference, const double &dcut) const
| return a vector of all subjets of the current jet (in the sense of the exclusive algorithm) that would be obtained when running the algorithm with the given dcut.
virtual int | n_exclusive_subjets (const PseudoJet &reference, const double &dcut) const
| return the size of exclusive_subjets(...); still n ln n with same coefficient, but marginally more efficient than manually taking exclusive_subjets.size()
virtual std::vector< PseudoJet > | exclusive_subjets_up_to (const PseudoJet &reference, int nsub) const
| return the list of subjets obtained by unclustering the supplied jet down to nsub subjets (or all constituents if there are fewer than nsub).
virtual double | exclusive_subdmerge (const PseudoJet &reference, int nsub) const
| return the dij that was present in the merging nsub+1 -> nsub subjets inside this jet.
virtual double | exclusive_subdmerge_max (const PseudoJet &reference, int nsub) const
| return the maximum dij that occurred in the whole event at the stage that the nsub+1 -> nsub merge of subjets occurred inside this jet.
virtual bool | has_pieces (const PseudoJet &) const
| return true if the structure supports pieces.
virtual std::vector< PseudoJet > | pieces (const PseudoJet &) const
| retrieve the pieces building the jet.
virtual bool | has_area () const
| check if it has a defined area
virtual double | area (const PseudoJet &reference) const
| return the jet (scalar) area.
virtual double | area_error (const PseudoJet &reference) const
| return the error (uncertainty) associated with the determination of the area of this jet.
virtual PseudoJet | area_4vector (const PseudoJet &reference) const
| return the jet 4-vector area.
virtual bool | is_pure_ghost (const PseudoJet &reference) const
| true if this jet is made exclusively of ghosts.

## Detailed Description

Contains any information related to the clustering that should be directly accessible to PseudoJet.

By default, this class implements basic access to the ClusterSequence related to a PseudoJet (like its constituents or its area). But it can be overloaded in order e.g. to give access to the jet substructure.

Definition at line 59 of file PseudoJetStructureBase.hh.

## Constructor & Destructor Documentation

## PseudoJetStructureBase()

fastjet::PseudoJetStructureBase::PseudoJetStructureBase | ( |  | ) |

inline

default ctor

Definition at line 62 of file PseudoJetStructureBase.hh.

## ~PseudoJetStructureBase()

virtual fastjet::PseudoJetStructureBase::~PseudoJetStructureBase | ( |  | ) |

inline virtual

default (virtual) dtor

Definition at line 65 of file PseudoJetStructureBase.hh.

## Member Function Documentation

## description()

virtual std::string fastjet::PseudoJetStructureBase::description | ( |  | ) | const

inline virtual

description

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, fastjet::FilterStructure, fastjet::PrunerStructure, fastjet::SISConeBasePlugin::UserScaleBase::StructureType, and fastjet::WrappedStructure.

Definition at line 68 of file PseudoJetStructureBase.hh.

## has_associated_cluster_sequence()

virtual bool fastjet::PseudoJetStructureBase::has_associated_cluster_sequence | ( |  | ) | const

inline virtual

returns true if there is an associated ClusterSequence

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 77 of file PseudoJetStructureBase.hh.

## associated_cluster_sequence()

const ClusterSequence * fastjet::PseudoJetStructureBase::associated_cluster_sequence | ( |  | ) | const

virtual

get a (const) pointer to the parent ClusterSequence (NULL if inexistent)

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 68 of file PseudoJetStructureBase.cc.

## has_valid_cluster_sequence()

virtual bool fastjet::PseudoJetStructureBase::has_valid_cluster_sequence | ( |  | ) | const

inline virtual

returns true if this PseudoJet has an associated and still valid ClusterSequence.

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 85 of file PseudoJetStructureBase.hh.

## validated_cs()

const ClusterSequence * fastjet::PseudoJetStructureBase::validated_cs | ( |  | ) | const

virtual

if the jet has a valid associated cluster sequence then return a pointer to it; otherwise throw an error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 76 of file PseudoJetStructureBase.cc.

## validated_csab()

const ClusterSequenceAreaBase * fastjet::PseudoJetStructureBase::validated_csab | ( |  | ) | const

virtual

if the jet has valid area information then return a pointer to the associated ClusterSequenceAreaBase object; otherwise throw an error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 85 of file PseudoJetStructureBase.cc.

## has_partner()

bool fastjet::PseudoJetStructureBase::has_partner | ( | const PseudoJet & | reference,
|  | PseudoJet & | partner ) const

virtual

check if it has been recombined with another PseudoJet in which case, return its partner through the argument.

Otherwise, 'partner' is set to 0.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 104 of file PseudoJetStructureBase.cc.

## has_child()

bool fastjet::PseudoJetStructureBase::has_child | ( | const PseudoJet & | reference,
|  | PseudoJet & | child ) const

virtual

check if it has been recombined with another PseudoJet in which case, return its child through the argument.

Otherwise, 'child' is set to 0.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 113 of file PseudoJetStructureBase.cc.

## has_parents()

bool fastjet::PseudoJetStructureBase::has_parents | ( | const PseudoJet & | reference,
|  | PseudoJet & | parent1,
|  | PseudoJet & | parent2 ) const

virtual

check if it is the product of a recombination, in which case return the 2 parents through the 'parent1' and 'parent2' arguments.

Otherwise, set these to 0.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 122 of file PseudoJetStructureBase.cc.

## object_in_jet()

bool fastjet::PseudoJetStructureBase::object_in_jet | ( | const PseudoJet & | reference,
|  | const PseudoJet & | jet ) const

virtual

check if the reference PseudoJet is contained the second one passed as argument.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 130 of file PseudoJetStructureBase.cc.

## has_constituents()

virtual bool fastjet::PseudoJetStructureBase::has_constituents | ( |  | ) | const

inline virtual

return true if the structure supports constituents.

false by default

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, fastjet::SISConeBasePlugin::UserScaleBase::StructureType, and fastjet::WrappedStructure.

Definition at line 139 of file PseudoJetStructureBase.hh.

## constituents()

vector< PseudoJet > fastjet::PseudoJetStructureBase::constituents | ( | const PseudoJet & | reference | ) | const

virtual

retrieve the constituents.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, fastjet::SISConeBasePlugin::UserScaleBase::StructureType, and fastjet::WrappedStructure.

Definition at line 137 of file PseudoJetStructureBase.cc.

## has_exclusive_subjets()

virtual bool fastjet::PseudoJetStructureBase::has_exclusive_subjets | ( |  | ) | const

inline virtual

return true if the structure supports exclusive_subjets.

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 148 of file PseudoJetStructureBase.hh.

## exclusive_subjets()

vector< PseudoJet > fastjet::PseudoJetStructureBase::exclusive_subjets | ( | const PseudoJet & | reference,
|  | const double & | dcut ) const

virtual

return a vector of all subjets of the current jet (in the sense of the exclusive algorithm) that would be obtained when running the algorithm with the given dcut.

Time taken is O(m ln m), where m is the number of subjets that are found. If m gets to be of order of the total number of constituents in the jet, this could be substantially slower than just getting that list of constituents.

By default, throws an Error

Note: in a future major release of FastJet (4 or higher), "const double & dcut" may be replaced with "const double dcut", requiring a modification of derived classes that overload this function.

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 151 of file PseudoJetStructureBase.cc.

## n_exclusive_subjets()

int fastjet::PseudoJetStructureBase::n_exclusive_subjets | ( | const PseudoJet & | reference,
|  | const double & | dcut ) const

virtual

return the size of exclusive_subjets(...); still n ln n with same coefficient, but marginally more efficient than manually taking exclusive_subjets.size()

By default, throws an Error

Note: in a future major release of FastJet (4 or higher), "const double & dcut" may be replaced with "const double dcut", requiring a modification of derived classes that overload this function.

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 160 of file PseudoJetStructureBase.cc.

## exclusive_subjets_up_to()

vector< PseudoJet > fastjet::PseudoJetStructureBase::exclusive_subjets_up_to | ( | const PseudoJet & | reference,
|  | int | nsub ) const

virtual

return the list of subjets obtained by unclustering the supplied jet down to nsub subjets (or all constituents if there are fewer than nsub).

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 169 of file PseudoJetStructureBase.cc.

## exclusive_subdmerge()

double fastjet::PseudoJetStructureBase::exclusive_subdmerge | ( | const PseudoJet & | reference,
|  | int | nsub ) const

virtual

return the dij that was present in the merging nsub+1 -> nsub subjets inside this jet.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 177 of file PseudoJetStructureBase.cc.

## exclusive_subdmerge_max()

double fastjet::PseudoJetStructureBase::exclusive_subdmerge_max | ( | const PseudoJet & | reference,
|  | int | nsub ) const

virtual

return the maximum dij that occurred in the whole event at the stage that the nsub+1 -> nsub merge of subjets occurred inside this jet.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, and fastjet::WrappedStructure.

Definition at line 186 of file PseudoJetStructureBase.cc.

## has_pieces()

virtual bool fastjet::PseudoJetStructureBase::has_pieces | ( | const PseudoJet & |  | ) | const

inline virtual

return true if the structure supports pieces.

false by default NB: "reference" is commented to avoid unused-variable compiler warnings

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, and fastjet::WrappedStructure.

Definition at line 207 of file PseudoJetStructureBase.hh.

## pieces()

std::vector< PseudoJet > fastjet::PseudoJetStructureBase::pieces | ( | const PseudoJet & |  | ) | const

virtual

retrieve the pieces building the jet.

By default, throws an Error. NB: "reference" is commented to avoid unused-variable compiler warnings

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, and fastjet::WrappedStructure.

Definition at line 194 of file PseudoJetStructureBase.cc.

## has_area()

virtual bool fastjet::PseudoJetStructureBase::has_area | ( |  | ) | const

inline virtual

check if it has a defined area

false by default

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, and fastjet::WrappedStructure.

Definition at line 226 of file PseudoJetStructureBase.hh.

## area()

double fastjet::PseudoJetStructureBase::area | ( | const PseudoJet & | reference | ) | const

virtual

return the jet (scalar) area.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, and fastjet::WrappedStructure.

Definition at line 206 of file PseudoJetStructureBase.cc.

## area_error()

double fastjet::PseudoJetStructureBase::area_error | ( | const PseudoJet & | reference | ) | const

virtual

return the error (uncertainty) associated with the determination of the area of this jet.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, and fastjet::WrappedStructure.

Definition at line 214 of file PseudoJetStructureBase.cc.

## area_4vector()

PseudoJet fastjet::PseudoJetStructureBase::area_4vector | ( | const PseudoJet & | reference | ) | const

virtual

return the jet 4-vector area.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, and fastjet::WrappedStructure.

Definition at line 221 of file PseudoJetStructureBase.cc.

## is_pure_ghost()

bool fastjet::PseudoJetStructureBase::is_pure_ghost | ( | const PseudoJet & | reference | ) | const

virtual

true if this jet is made exclusively of ghosts.

By default, throws an Error

Reimplemented in fastjet::ClusterSequenceStructure, fastjet::CompositeJetStructure, and fastjet::WrappedStructure.

Definition at line 228 of file PseudoJetStructureBase.cc.

The documentation for this class was generated from the following files:

- include/fastjet/PseudoJetStructureBase.hh
- src/PseudoJetStructureBase.cc